<?php
/**
 * @Package			Digitest Debug
 * @Copyright		Fabrizio Galuppi - Digitest.net
 * @license			http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Email			public2@digitest.net
 * web:				https://www.digitest.net
 * Version:			3.0.1
 */

defined('_JEXEC') or die('Direct access forbidden!');

use Joomla\CMS\Factory;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Helper\ModuleHelper;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Version;


class plgSystemDigitestdebug extends JPlugin
{
	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}
	
	function onAfterRender($toArray = false)
	{
		
	
		ini_set('error_reporting', 32759);
		
		$jVersion = new Version();
		
		$app				= Factory::getApplication();
		
		// If Administrator area   ->exit ===========================================
		if($app->isClient('administrator'))
		{
			return;
		}
		
		
		$doc				= Factory::getDocument();
		$option				= $app->input->getCmd('option', '');
		$view				= $app->input->getCmd('view', '');
		$layout 			= $app->input->getCmd('layout', 'undefined');
		$page 				= $app->input->getCmd('page', 'undefined');
		$task 				= $app->input->getCmd('task', 'undefined');
		
		if($option == "com_content"){
			$temp				= $app->input->getString('id', '');
			$temp				= explode(':', $temp);
			$art				= $temp[0];
		}else{
			$art				= "Not an Article";
		}
		
		// Shutdown on some Extensions
		if($option == "com_eyesite")
		{
			return;
		}
		
		$menu_id 			= $app->getMenu()->getActive()->id;
		
		$lang 				= Factory::getLanguage();
		$lang_tag			= substr($lang->getTag(),0,2);
		$user				= Factory::getUser();	
		
		$menu				= $app->getMenu()->getActive();
  		$page_class			= '';
  		$page_heading		= '';
  		$blog_class			= '';
  		if (is_object($menu)){
			$page_class		= $menu->getParams()->get('pageclass_sfx');
			$page_heading	= $menu->getParams()->get('page_heading');
			$blog_class		= $menu->getParams()->get('blog_class');
//			$page_class		= $menu->getParams();
		}
		
		// Get some Params ==========================================================
		$myUserIds			= $this->params->get('myUserIds', 0);
		$ModPosCounter		= $this->params->get('ModPosCounter', 0);
		$showTemplateParams	= $this->params->get('showTemplateParams', 0);
		$textColor			= $this->params->get('textColor', '#444');
		$theme				= $this->params->get('theme', 0);
		$bkgColor			= '#FFF';
//		$outputPos			= $this->params->get('outputPos', 'bottom'); // Future versions
		
		$ModCounter			= count(ModuleHelper::getModules($ModPosCounter));
		
		if($theme == 1){$textColor = '#ffffff';$bkgColor = '#444';};
		
		// Set CSS Style ============================================================
		$style				= '<style>';
		$style				.= 'div#digi-debug-cnt{
									display:flex;
									color:' . $textColor .';
									text-align:left;
									margin:0;
									padding:0 24px;
									font-family:Geneva,Courier New,sans-serif;
									font-size:14px;
									box-sizing:border-box;
									line-height:22px;
									min-height:350px;
									border-top:1px solid #CCC;
									background-color:' . $bkgColor . ';
								}
								div.digi-debug-item{
									width:50%;
									padding-bottom: 36px;
								}
								span.yes{
									background-color: #48aa48;
  									color: #FFF;
  									padding: 0 6px;
  									border-radius: 6px;
								}
								span.no{
									background-color: #d75555;
  									color: #FFF;
  									padding: 0 6px;
  									border-radius: 6px;
								}
								@media only screen and (max-width:760px){
									div#digi-debug-cnt{
										flex-direction:column;
									}
									div.digi-debug-item{
										width:100%;
										padding-bottom: 12px;
									}
								}
									';	
		
		$style				.= '</style></head>';
		
		
		// Get Category ID ==========================================================
		$db = Factory::getDBO();
		if ($view == "category") {
			$category_id = $app->input->getCmd('id');
		}elseif ($view == "article"){
			$query = "SELECT catid FROM #__content WHERE id = ".$art;
			 $db->setQuery($query);
			$category_id = $db->loadResult();
		}else{
			$category_id = "undefined";
		}
		
		// Check for my and commons PlugIn & Extensions =============================
		$plg_opengraph = PluginHelper::getPlugin('content', 'phocaopengraph');
		if($plg_opengraph){$plg_opengraph = '<span class="yes">Yes</span>';
						  }else{$plg_opengraph = '<span class="no">No</span>'; };
		
		$plg_titleext = PluginHelper::getPlugin('system', 'page_title_extended');
		if($plg_titleext){$plg_titleext = '<span class="yes">Yes</span>';
						 }else{$plg_titleext = '<span class="no">No</span>'; };
		
		$plg_ksecure = PluginHelper::getPlugin('system', 'ksecure');
		if($plg_ksecure){$plg_ksecure = '<span class="yes">Yes</span>';
						}else{$plg_ksecure = '<span class="no">No</span>'; };
		
		$plg_policy = PluginHelper::getPlugin('system', 'cookiespolicynotificationbar');
		if($plg_policy){$plg_policy = '<span class="yes">Yes</span>';
						}else{$plg_policy = '<span class="no">No</span>'; };		
		
		$plg_mobile_detect = PluginHelper::getPlugin('system', 'yagendoomobiledetection');
		if($plg_mobile_detect){$plg_mobile_detect = '<span class="yes">Yes</span>';
						}else{$plg_mobile_detect = '<span class="no">No</span>'; };	
		
		$com_akeeba = ComponentHelper::isEnabled('com_akeebabackup');
		if($com_akeeba){$com_akeeba = '<span class="yes">Yes</span>';
					   }else{$com_akeeba = '<span class="no">No</span>'; };
		
		$com_convertforms = ComponentHelper::isEnabled('com_convertforms');
		if($com_convertforms){$com_convertforms = '<span class="yes">Yes</span>';
					}else{$com_convertforms = '<span class="no">No</span>'; };
		
		$com_rstbox = ComponentHelper::isEnabled('com_rstbox');
		if($com_rstbox){$com_rstbox = '<span class="yes">Yes</span>';
					}else{$com_rstbox = '<span class="no">No</span>'; };
		
		$com_bfstop = ComponentHelper::isEnabled('com_bfstop');
		if($com_bfstop){$com_bfstop = '<span class="yes">Yes</span>';
					   }else{$com_bfstop = '<span class="no">No</span>'; };
		
		$com_osmap = ComponentHelper::isEnabled('com_osmap');
		if($com_osmap){$com_osmap = '<span class="yes">Yes</span>';
					   }else{$com_osmap = '<span class="no">No</span>'; };
		
		
		// Get Template params (if Digitest Templates) ==============================
		$templateParam		= $app->getTemplate(true);
		$params				= $templateParam->params;
		
		//$modernizr			= $params->get('modernizr', '0');
		$responsivemenu		= $params->get('responsivemenu', '0');
		$setjquery			= $params->get('setjquery', '0');
		$setmootools		= $params->get('setmootools', '0');
		$setbootstrap		= $params->get('setbootstrap', '0');
		$testMessage		= $params->get('testMessage', '0');
		$setToTop			= $params->get('setToTop', '0');
		$enableAnalytics	= $params->get('enableAnalytics', '0');
		$enableRemarketing	= $params->get('enableRemarketing', '0');        
		$setscrollReveal	= $params->get('setscrollReveal', '0');	
		
		// Get USER device and browser ==============================================
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		$mobileDeviceName = null;
		switch( true ){
			case ( preg_match( '/ipod/i', $user_agent ) || preg_match( '/iphone/i', $user_agent ) ):
				$mobileDeviceName = 'iPhone';
			break;
			case ( preg_match( '/ipad/i', $user_agent ) ):
				$mobileDeviceName = 'iPad';
			break;
			case ( preg_match( '/android/i', $user_agent ) ):
				$mobileDeviceName = 'Android';
			break;
			case ( preg_match( '/opera mini/i', $user_agent ) ):
				$mobileDeviceName = 'Opera';
			break;
			case ( preg_match( '/blackberry/i', $user_agent ) ):
				$mobileDeviceName = 'Blackberry';
			break;
			case ( preg_match( '/(pre\/|palm os|palm|hiptop|avantgo|plucker|xiino|blazer|elaine)/i', $user_agent ) ):
				$mobileDeviceName = 'Palm';
			break;
			case ( preg_match( '/(windows ce; ppc;|windows mobile;|windows ce; smartphone;|windows ce; iemobile|windows phone)/i', $user_agent ) ):
				$mobileDeviceName = 'Windows';
			break;
			default:
				$mobileDeviceName = "PC";
			}
		
		if ($mobileDeviceName == "PC"){
			$DeviceType = "Desktop";
		}else{
			$DeviceType = "Mobile";
		};
		
    	$bname = 'Unknown';
    	$ub = 'Unknown';
    	$platform = 'Unknown';
    	$version= "Deprecated";

    	// Platform
    	if (preg_match('/linux/i', $user_agent)){
			$platform = 'Linux';
		}elseif (preg_match('/macintosh|mac os x/i', $user_agent)){
			$platform = 'Mac';
		}elseif (preg_match('/windows|win32/i', $user_agent)){
			$platform = 'Windows';
		}
   
    	// User Agent
    	if(preg_match('/MSIE/i',$user_agent) && !preg_match('/Opera/i',$user_agent)){
        $bname = 'Internet Explorer';
        $ub = "MSIE";}
    	elseif(preg_match('/Firefox/i',$user_agent)){
        $bname = 'Mozilla Firefox';
        $ub = "Firefox";}
    	elseif(preg_match('/Chrome/i',$user_agent)){
        $bname = 'Google Chrome';
        $ub = "Chrome";}
    	elseif(preg_match('/Safari/i',$user_agent)){
        $bname = 'Apple Safari';
        $ub = "Safari";}
    	elseif(preg_match('/Opera/i',$user_agent)){
        $bname = 'Opera';
        $ub = "Opera";}
    	elseif(preg_match('/Netscape/i',$user_agent)){
        $bname = 'Netscape';
        $ub = "Netscape";}
   
    	// Version number
    	$known = array('Version', $ub, 'other');
    	$pattern = '#(?<browser>' . join('|', $known) .')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
    	if (!preg_match_all($pattern, $user_agent, $matches)) {
        // Do nothing
    	}
   
    	// Checking 
//    	$i = count($matches['browser']);
//    	if ($i != 1) {
//			if (strripos($user_agent,"Version") < strripos($user_agent,$ub)){
//				$version= $matches['version'][0];
//			}else{
//            $version= $matches['version'][1];
//			}
//		}else {
//        $version= $matches['version'][0];
//		}
   
    	// Checking for a number
    	if ($version==null || $version=="") {$version="?";}
		$showUserAgent = array(
			'userAgent' => $user_agent,
			'name'      => $bname,
			'version'   => $version,
			'platform'  => $platform,
			'pattern'	=> $pattern);		
		
		// IF not logged in   ->exit ================================================
		
		$user				= Factory::getUser();
		$userId				= $user->id;
		
		$myUserId = explode(',', $myUserIds);
		
		if(!in_array($userId,$myUserId)){
			return;
		}		
		
		// Compiler =================================================================
		//$html = JResponse::getBody();
		$html = Factory::getApplication()->getBody();
        
		$contenuto = '<div id="digi-debug-cnt">';
		
		$contenuto .= '<div class="digi-debug-item">';		
		$contenuto .= '<br /><b>CMS Output Variables & Parameters</b>';
		$contenuto .= '<br />&nbsp;Option = ' . $option;
		$contenuto .= '<br />&nbsp;View = ' . $view;
		$contenuto .= '<br />&nbsp;Layout = ' . $layout;
		$contenuto .= '<br />&nbsp;Page = ' . $page;
		$contenuto .= '<br />&nbsp;Task = ' . $task;		
		$contenuto .= '<br />&nbsp;Menu ID = ' . $menu_id;	
		$contenuto .= '<br />&nbsp;Element ID (Art) = ' . $art;
		$contenuto .= '<br />&nbsp;Category ID = ' . $category_id;
		
		$contenuto .= '<br />&nbsp;Page Heading = ' . $page_heading;
		$contenuto .= '<br />&nbsp;Page Class = ' . $page_class;
		$contenuto .= '<br />&nbsp;Blog Class = ' . $blog_class;
		
		$contenuto .= '<br />---------------------------';
		$contenuto .= '<br />Language = ' . $lang_tag;
		$contenuto .= '<br />Logged User ID = ' . $userId;
		
		$contenuto .= '<br />---------------------------';		
		$contenuto .= '<br />Module Counter (pos: '. $ModPosCounter .') = ' . $ModCounter;
		
		$contenuto .= '<br />---------------------------';
		$contenuto .= '<br /><b>USER Agent</b>';
		$contenuto .= '<br />&nbsp;Device Type = ' . $DeviceType . '/' . $mobileDeviceName;
		$contenuto .= '<br />&nbsp;Platform = ' . $showUserAgent['platform'];
		$contenuto .= '<br />&nbsp;Browser = ' . $showUserAgent['name'];	
		
		$contenuto .= '<br /><br /></div>';
		$contenuto .= '<div class="digi-debug-item">';
		
		if($showTemplateParams){		
			$contenuto .= '<br /><b>Custom Template Params (Digitest)</b>';
			$contenuto .= '<br />&nbsp;Scroll Reveal = ' . $setscrollReveal;
			$contenuto .= '<br />&nbsp;Test Messages = ' . $testMessage;
			$contenuto .= '<br />&nbsp;Pulsante Torna su = ' . $setToTop;
			$contenuto .= '<br />---------------------------';
		}
		
		$contenuto .= '<br /><b>Common Extensions Status (Installed &amp; Active)</b>';
		$contenuto .= '<br />&nbsp;OpenGraph = ' . $plg_opengraph;
		$contenuto .= '<br />&nbsp;Page Title Extended = ' . $plg_titleext;
		$contenuto .= '<br />&nbsp;Cookies Policy 357 = ' . $plg_policy;
		$contenuto .= '<br />&nbsp;Mobile Detect = ' . $plg_mobile_detect;
		$contenuto .= '<br />&nbsp;K Secure = ' . $plg_ksecure;
		$contenuto .= '<br />&nbsp;Akeeba BKP = ' . $com_akeeba;
		$contenuto .= '<br />&nbsp;Engage Box = ' . $com_rstbox;
		$contenuto .= '<br />&nbsp;Convert Form = ' . $com_convertforms;
		$contenuto .= '<br />&nbsp;Brute Force Stop = ' . $com_bfstop;
		$contenuto .= '<br />&nbsp;OS Map = ' . $com_osmap;
		
		$contenuto .= '<br />---------------------------';
		$contenuto .= '<br /><b>System Data</b>';
		$contenuto .= '<br />&nbsp;Joomla Version = ' . $jVersion->getShortVersion();
		$contenuto .= '<br />&nbsp;PHP Version = ' . phpversion();
		
		if(version_compare(PHP_VERSION, '8.0.0', '<')){
			$contenuto .= '<br/ >&nbsp;<span style="color:red;">It is time to upgrade your server to PHP8 !!!</span>';
		}
		
        $contenuto .= '<br/ >&nbsp;PLG Digitest Debug ver. 3.0.1';
		$contenuto .= '<br /></div></div></body>';	
			
		// Set Plugin Output
		$html = preg_replace('@<\/body>@i', $contenuto, $html, 1);
		Factory::getApplication()->setBody($html);
		
		// Set css style
		$css = preg_replace('@<\/head>@i', $style, $html, 1);
		Factory::getApplication()->setBody($css);
	
	} // end function
}